int dyngen_code(uint8_t *gen_code_buf,
                uint16_t *label_offsets, uint16_t *jmp_offsets,
                const uint16_t *opc_buf, const uint32_t *opparam_buf, const long *gen_labels)
{
    uint8_t *gen_code_ptr;
    const uint16_t *opc_ptr;
    const uint32_t *opparam_ptr;

    gen_code_ptr = gen_code_buf;
    opc_ptr = opc_buf;
    opparam_ptr = opparam_buf;
    for(;;) {
        switch(*opc_ptr++) {
case INDEX_op_mov32: {
    long param1, param2;
    extern void op_mov32();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_mov32+0), 24);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 13) = param1 - (long)(gen_code_ptr + 13) + -4;
    *(uint32_t *)(gen_code_ptr + 20) = (long)(&helper_set_op) - (long)(gen_code_ptr + 20) + -4;
    gen_code_ptr += 24;
}
break;

case INDEX_op_mov32_im: {
    long param1, param2;
    extern void op_mov32_im();
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_mov32_im+0), 17);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = param1 - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 13) = (long)(&helper_set_op) - (long)(gen_code_ptr + 13) + -4;
    gen_code_ptr += 17;
}
break;

case INDEX_op_movf64: {
    long param1, param2;
    extern void op_movf64();
extern char helper_get_opf64;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_movf64+0), 25);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 13) = param1 - (long)(gen_code_ptr + 13) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 21) + -4;
    gen_code_ptr += 25;
}
break;

case INDEX_op_zerof64: {
    long param1;
    extern void op_zerof64();
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_zerof64+0), 13);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 9) + -4;
    gen_code_ptr += 13;
}
break;

case INDEX_op_add32: {
    long param1, param2, param3;
    extern void op_add32();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_add32+0), 40);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param2 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param3 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    *(uint32_t *)(gen_code_ptr + 27) = param1 - (long)(gen_code_ptr + 27) + -4;
    *(uint32_t *)(gen_code_ptr + 35) = (long)(&helper_set_op) - (long)(gen_code_ptr + 35) + -4;
    gen_code_ptr += 40;
}
break;

case INDEX_op_sub32: {
    long param1, param2, param3;
    extern void op_sub32();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_sub32+0), 41);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param2 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param3 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    *(uint32_t *)(gen_code_ptr + 27) = param1 - (long)(gen_code_ptr + 27) + -4;
    *(uint32_t *)(gen_code_ptr + 36) = (long)(&helper_set_op) - (long)(gen_code_ptr + 36) + -4;
    gen_code_ptr += 41;
}
break;

case INDEX_op_mul32: {
    long param1, param2, param3;
    extern void op_mul32();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_mul32+0), 42);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param2 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param3 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    *(uint32_t *)(gen_code_ptr + 30) = param1 - (long)(gen_code_ptr + 30) + -4;
    *(uint32_t *)(gen_code_ptr + 37) = (long)(&helper_set_op) - (long)(gen_code_ptr + 37) + -4;
    gen_code_ptr += 42;
}
break;

case INDEX_op_not32: {
    long param1, param2;
    extern void op_not32();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_not32+0), 26);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 13) = param1 - (long)(gen_code_ptr + 13) + -4;
    *(uint32_t *)(gen_code_ptr + 22) = (long)(&helper_set_op) - (long)(gen_code_ptr + 22) + -4;
    gen_code_ptr += 26;
}
break;

case INDEX_op_neg32: {
    long param1, param2;
    extern void op_neg32();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_neg32+0), 26);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 13) = param1 - (long)(gen_code_ptr + 13) + -4;
    *(uint32_t *)(gen_code_ptr + 22) = (long)(&helper_set_op) - (long)(gen_code_ptr + 22) + -4;
    gen_code_ptr += 26;
}
break;

case INDEX_op_bswap32: {
    long param1, param2;
    extern void op_bswap32();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_bswap32+0), 57);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 17) = param1 - (long)(gen_code_ptr + 17) + -4;
    *(uint32_t *)(gen_code_ptr + 53) = (long)(&helper_set_op) - (long)(gen_code_ptr + 53) + -4;
    gen_code_ptr += 57;
}
break;

case INDEX_op_btest: {
    long param1, param2;
    extern void op_btest();
extern char helper_get_op;
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_btest+0), 42);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param1 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param2 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    gen_code_ptr += 42;
}
break;

case INDEX_op_ff1: {
    long param1, param2;
    extern void op_ff1();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ff1+0), 37);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 28) = param1 - (long)(gen_code_ptr + 28) + -4;
    *(uint32_t *)(gen_code_ptr + 33) = (long)(&helper_set_op) - (long)(gen_code_ptr + 33) + -4;
    gen_code_ptr += 37;
}
break;

case INDEX_op_subx_cc: {
    long param1, param2;
    extern void op_subx_cc();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_subx_cc+0), 96);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param1 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param2 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    *(uint32_t *)(gen_code_ptr + 86) = param1 - (long)(gen_code_ptr + 86) + -4;
    *(uint32_t *)(gen_code_ptr + 91) = (long)(&helper_set_op) - (long)(gen_code_ptr + 91) + -4;
    gen_code_ptr += 96;
}
break;

case INDEX_op_addx_cc: {
    long param1, param2;
    extern void op_addx_cc();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_addx_cc+0), 94);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param1 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param2 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    *(uint32_t *)(gen_code_ptr + 84) = param1 - (long)(gen_code_ptr + 84) + -4;
    *(uint32_t *)(gen_code_ptr + 89) = (long)(&helper_set_op) - (long)(gen_code_ptr + 89) + -4;
    gen_code_ptr += 94;
}
break;

case INDEX_op_and32: {
    long param1, param2, param3;
    extern void op_and32();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_and32+0), 41);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param2 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param3 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    *(uint32_t *)(gen_code_ptr + 27) = param1 - (long)(gen_code_ptr + 27) + -4;
    *(uint32_t *)(gen_code_ptr + 36) = (long)(&helper_set_op) - (long)(gen_code_ptr + 36) + -4;
    gen_code_ptr += 41;
}
break;

case INDEX_op_or32: {
    long param1, param2, param3;
    extern void op_or32();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_or32+0), 41);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param2 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param3 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    *(uint32_t *)(gen_code_ptr + 27) = param1 - (long)(gen_code_ptr + 27) + -4;
    *(uint32_t *)(gen_code_ptr + 36) = (long)(&helper_set_op) - (long)(gen_code_ptr + 36) + -4;
    gen_code_ptr += 41;
}
break;

case INDEX_op_xor32: {
    long param1, param2, param3;
    extern void op_xor32();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_xor32+0), 41);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param2 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param3 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    *(uint32_t *)(gen_code_ptr + 27) = param1 - (long)(gen_code_ptr + 27) + -4;
    *(uint32_t *)(gen_code_ptr + 36) = (long)(&helper_set_op) - (long)(gen_code_ptr + 36) + -4;
    gen_code_ptr += 41;
}
break;

case INDEX_op_shl32: {
    long param1, param2, param3;
    extern void op_shl32();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_shl32+0), 43);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param2 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param3 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    *(uint32_t *)(gen_code_ptr + 29) = param1 - (long)(gen_code_ptr + 29) + -4;
    *(uint32_t *)(gen_code_ptr + 38) = (long)(&helper_set_op) - (long)(gen_code_ptr + 38) + -4;
    gen_code_ptr += 43;
}
break;

case INDEX_op_shl_cc: {
    long param1, param2;
    extern void op_shl_cc();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_shl_cc+0), 97);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 7) = (uint32_t)param1 + 0;
    *(uint32_t *)(gen_code_ptr + 29) = (long)(&helper_get_op) - (long)(gen_code_ptr + 29) + -4;
    *(uint32_t *)(gen_code_ptr + 35) = param2 - (long)(gen_code_ptr + 35) + -4;
    *(uint32_t *)(gen_code_ptr + 43) = (long)(&helper_get_op) - (long)(gen_code_ptr + 43) + -4;
    *(uint32_t *)(gen_code_ptr + 62) = (long)(&helper_set_op) - (long)(gen_code_ptr + 62) + -4;
    gen_code_ptr += 97;
}
break;

case INDEX_op_shr32: {
    long param1, param2, param3;
    extern void op_shr32();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_shr32+0), 43);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param2 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param3 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    *(uint32_t *)(gen_code_ptr + 29) = param1 - (long)(gen_code_ptr + 29) + -4;
    *(uint32_t *)(gen_code_ptr + 38) = (long)(&helper_set_op) - (long)(gen_code_ptr + 38) + -4;
    gen_code_ptr += 43;
}
break;

case INDEX_op_shr_cc: {
    long param1, param2;
    extern void op_shr_cc();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_shr_cc+0), 97);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 7) = (uint32_t)param1 + 0;
    *(uint32_t *)(gen_code_ptr + 29) = (long)(&helper_get_op) - (long)(gen_code_ptr + 29) + -4;
    *(uint32_t *)(gen_code_ptr + 35) = param2 - (long)(gen_code_ptr + 35) + -4;
    *(uint32_t *)(gen_code_ptr + 43) = (long)(&helper_get_op) - (long)(gen_code_ptr + 43) + -4;
    *(uint32_t *)(gen_code_ptr + 62) = (long)(&helper_set_op) - (long)(gen_code_ptr + 62) + -4;
    gen_code_ptr += 97;
}
break;

case INDEX_op_sar32: {
    long param1, param2, param3;
    extern void op_sar32();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_sar32+0), 43);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param2 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param3 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    *(uint32_t *)(gen_code_ptr + 29) = param1 - (long)(gen_code_ptr + 29) + -4;
    *(uint32_t *)(gen_code_ptr + 38) = (long)(&helper_set_op) - (long)(gen_code_ptr + 38) + -4;
    gen_code_ptr += 43;
}
break;

case INDEX_op_sar_cc: {
    long param1, param2;
    extern void op_sar_cc();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_sar_cc+0), 97);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 7) = (uint32_t)param1 + 0;
    *(uint32_t *)(gen_code_ptr + 29) = (long)(&helper_get_op) - (long)(gen_code_ptr + 29) + -4;
    *(uint32_t *)(gen_code_ptr + 35) = param2 - (long)(gen_code_ptr + 35) + -4;
    *(uint32_t *)(gen_code_ptr + 43) = (long)(&helper_get_op) - (long)(gen_code_ptr + 43) + -4;
    *(uint32_t *)(gen_code_ptr + 62) = (long)(&helper_set_op) - (long)(gen_code_ptr + 62) + -4;
    gen_code_ptr += 97;
}
break;

case INDEX_op_ext8u32: {
    long param1, param2;
    extern void op_ext8u32();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ext8u32+0), 25);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 13) = param1 - (long)(gen_code_ptr + 13) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_set_op) - (long)(gen_code_ptr + 21) + -4;
    gen_code_ptr += 25;
}
break;

case INDEX_op_ext8s32: {
    long param1, param2;
    extern void op_ext8s32();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ext8s32+0), 25);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 13) = param1 - (long)(gen_code_ptr + 13) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_set_op) - (long)(gen_code_ptr + 21) + -4;
    gen_code_ptr += 25;
}
break;

case INDEX_op_ext16u32: {
    long param1, param2;
    extern void op_ext16u32();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ext16u32+0), 25);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 13) = param1 - (long)(gen_code_ptr + 13) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_set_op) - (long)(gen_code_ptr + 21) + -4;
    gen_code_ptr += 25;
}
break;

case INDEX_op_ext16s32: {
    long param1, param2;
    extern void op_ext16s32();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ext16s32+0), 25);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 13) = param1 - (long)(gen_code_ptr + 13) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_set_op) - (long)(gen_code_ptr + 21) + -4;
    gen_code_ptr += 25;
}
break;

case INDEX_op_flush_flags: {
    extern void op_flush_flags();
extern char cpu_m68k_flush_flags;
    memcpy(gen_code_ptr, (void *)((char *)&op_flush_flags+0), 20);
    *(uint32_t *)(gen_code_ptr + 12) = (long)(&cpu_m68k_flush_flags) - (long)(gen_code_ptr + 12) + -4;
    gen_code_ptr += 20;
}
break;

case INDEX_op_divu: {
    long param1;
    extern void op_divu();
extern char cpu_loop_exit;
    memcpy(gen_code_ptr, (void *)((char *)&op_divu+0), 129);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 36) = (long)(&cpu_loop_exit) - (long)(gen_code_ptr + 36) + -4;
    *(uint32_t *)(gen_code_ptr + 51) = (uint32_t)param1 + 0;
    gen_code_ptr += 129;
}
break;

case INDEX_op_divs: {
    long param1;
    extern void op_divs();
extern char cpu_loop_exit;
    memcpy(gen_code_ptr, (void *)((char *)&op_divs+0), 140);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 44) = (long)(&cpu_loop_exit) - (long)(gen_code_ptr + 44) + -4;
    *(uint32_t *)(gen_code_ptr + 63) = (uint32_t)param1 + 0;
    gen_code_ptr += 140;
}
break;

case INDEX_op_halt: {
    extern void op_halt();
extern char cpu_loop_exit;
    memcpy(gen_code_ptr, (void *)((char *)&op_halt+0), 24);
    *(uint32_t *)(gen_code_ptr + 16) = (long)(&cpu_loop_exit) - (long)(gen_code_ptr + 16) + -4;
    gen_code_ptr += 24;
}
break;

case INDEX_op_stop: {
    extern void op_stop();
extern char cpu_loop_exit;
    memcpy(gen_code_ptr, (void *)((char *)&op_stop+0), 35);
    *(uint32_t *)(gen_code_ptr + 27) = (long)(&cpu_loop_exit) - (long)(gen_code_ptr + 27) + -4;
    gen_code_ptr += 35;
}
break;

case INDEX_op_raise_exception: {
    long param1;
    extern void op_raise_exception();
extern char cpu_loop_exit;
    memcpy(gen_code_ptr, (void *)((char *)&op_raise_exception+0), 25);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 1) = (uint32_t)param1 + 0;
    *(uint32_t *)(gen_code_ptr + 17) = (long)(&cpu_loop_exit) - (long)(gen_code_ptr + 17) + -4;
    gen_code_ptr += 25;
}
break;

case INDEX_op_sub_cmpf64: {
    long param1, param2, param3;
    extern void op_sub_cmpf64();
extern char helper_get_opf64;
extern char helper_get_opf64;
extern char helper_sub_cmpf64;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_sub_cmpf64+0), 55);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param2 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param3 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 22) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 22) + -4;
    *(uint32_t *)(gen_code_ptr + 36) = (long)(&helper_sub_cmpf64) - (long)(gen_code_ptr + 36) + -4;
    *(uint32_t *)(gen_code_ptr + 42) = param1 - (long)(gen_code_ptr + 42) + -4;
    *(uint32_t *)(gen_code_ptr + 50) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 50) + -4;
    gen_code_ptr += 55;
}
break;

case INDEX_op_update_xflag_tst: {
    long param1;
    extern void op_update_xflag_tst();
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_update_xflag_tst+0), 15);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    gen_code_ptr += 15;
}
break;

case INDEX_op_update_xflag_lt: {
    long param1, param2;
    extern void op_update_xflag_lt();
extern char helper_get_op;
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_update_xflag_lt+0), 38);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param1 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param2 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    gen_code_ptr += 38;
}
break;

case INDEX_op_get_xflag: {
    long param1;
    extern void op_get_xflag();
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_get_xflag+0), 15);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 6) = param1 - (long)(gen_code_ptr + 6) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_set_op) - (long)(gen_code_ptr + 11) + -4;
    gen_code_ptr += 15;
}
break;

case INDEX_op_logic_cc: {
    long param1;
    extern void op_logic_cc();
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_logic_cc+0), 15);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    gen_code_ptr += 15;
}
break;

case INDEX_op_update_cc_add: {
    long param1, param2;
    extern void op_update_cc_add();
extern char helper_get_op;
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_update_cc_add+0), 34);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param1 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param2 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    gen_code_ptr += 34;
}
break;

case INDEX_op_fp_result: {
    long param1;
    extern void op_fp_result();
extern char helper_get_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_fp_result+0), 18);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 7) + -4;
    gen_code_ptr += 18;
}
break;

case INDEX_op_set_sr: {
    long param1;
    extern void op_set_sr();
extern char helper_get_op;
extern char m68k_switch_sp;
    memcpy(gen_code_ptr, (void *)((char *)&op_set_sr+0), 36);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_op) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 28) = (long)(&m68k_switch_sp) - (long)(gen_code_ptr + 28) + -4;
    gen_code_ptr += 36;
}
break;

case INDEX_op_jmp: {
    long param1;
    extern void op_jmp();
    memcpy(gen_code_ptr, (void *)((char *)&op_jmp+0), 5);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 1) = gen_labels[param1] - (long)(gen_code_ptr + 1) + -4;
    gen_code_ptr += 5;
}
break;

case INDEX_op_set_T0_z32: {
    long param1;
    extern void op_set_T0_z32();
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_set_T0_z32+0), 20);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    gen_code_ptr += 20;
}
break;

case INDEX_op_set_T0_nz32: {
    long param1;
    extern void op_set_T0_nz32();
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_set_T0_nz32+0), 20);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    gen_code_ptr += 20;
}
break;

case INDEX_op_set_T0_s32: {
    long param1;
    extern void op_set_T0_s32();
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_set_T0_s32+0), 20);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    gen_code_ptr += 20;
}
break;

case INDEX_op_set_T0_ns32: {
    long param1;
    extern void op_set_T0_ns32();
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_set_T0_ns32+0), 20);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    gen_code_ptr += 20;
}
break;

case INDEX_op_jmp_T0: {
    long param1;
    extern void op_jmp_T0();
    memcpy(gen_code_ptr, (void *)((char *)&op_jmp_T0+0), 10);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 6) = gen_labels[param1] - (long)(gen_code_ptr + 6) + -4;
    gen_code_ptr += 10;
}
break;

case INDEX_op_goto_tb0: {
    long param1;
    extern void op_goto_tb0();
    memcpy(gen_code_ptr, (void *)((char *)&op_goto_tb0+0), 9);
    label_offsets[0] = 8 + (gen_code_ptr - gen_code_buf);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + 64;
    gen_code_ptr += 9;
}
break;

case INDEX_op_goto_tb1: {
    long param1;
    extern void op_goto_tb1();
    memcpy(gen_code_ptr, (void *)((char *)&op_goto_tb1+0), 9);
    label_offsets[1] = 8 + (gen_code_ptr - gen_code_buf);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + 68;
    gen_code_ptr += 9;
}
break;

case INDEX_op_exit_tb: {
    extern void op_exit_tb();
    memcpy(gen_code_ptr, (void *)((char *)&op_exit_tb+0), 1);
    gen_code_ptr += 1;
}
break;

case INDEX_op_f64_to_i32: {
    long param1, param2;
    extern void op_f64_to_i32();
extern char helper_get_opf64;
extern char float64_to_int32;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_f64_to_i32+0), 47);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 26) = (long)(&float64_to_int32) - (long)(gen_code_ptr + 26) + -4;
    *(uint32_t *)(gen_code_ptr + 32) = param1 - (long)(gen_code_ptr + 32) + -4;
    *(uint32_t *)(gen_code_ptr + 39) = (long)(&helper_set_op) - (long)(gen_code_ptr + 39) + -4;
    gen_code_ptr += 47;
}
break;

case INDEX_op_f64_to_f32: {
    long param1, param2;
    extern void op_f64_to_f32();
extern char helper_get_opf64;
extern char float64_to_float32;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_f64_to_f32+0), 47);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 26) = (long)(&float64_to_float32) - (long)(gen_code_ptr + 26) + -4;
    *(uint32_t *)(gen_code_ptr + 32) = param1 - (long)(gen_code_ptr + 32) + -4;
    *(uint32_t *)(gen_code_ptr + 39) = (long)(&helper_set_op) - (long)(gen_code_ptr + 39) + -4;
    gen_code_ptr += 47;
}
break;

case INDEX_op_i32_to_f64: {
    long param1, param2;
    extern void op_i32_to_f64();
extern char helper_get_op;
extern char int32_to_float64;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_i32_to_f64+0), 47);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_op) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 25) = (long)(&int32_to_float64) - (long)(gen_code_ptr + 25) + -4;
    *(uint32_t *)(gen_code_ptr + 31) = param1 - (long)(gen_code_ptr + 31) + -4;
    *(uint32_t *)(gen_code_ptr + 39) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 39) + -4;
    gen_code_ptr += 47;
}
break;

case INDEX_op_f32_to_f64: {
    long param1, param2;
    extern void op_f32_to_f64();
extern char helper_get_op;
extern char float32_to_float64;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_f32_to_f64+0), 47);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_op) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 25) = (long)(&float32_to_float64) - (long)(gen_code_ptr + 25) + -4;
    *(uint32_t *)(gen_code_ptr + 31) = param1 - (long)(gen_code_ptr + 31) + -4;
    *(uint32_t *)(gen_code_ptr + 39) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 39) + -4;
    gen_code_ptr += 47;
}
break;

case INDEX_op_absf64: {
    long param1, param2;
    extern void op_absf64();
extern char helper_get_opf64;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_absf64+0), 38);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 13) = param1 - (long)(gen_code_ptr + 13) + -4;
    *(uint32_t *)(gen_code_ptr + 34) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 34) + -4;
    gen_code_ptr += 38;
}
break;

case INDEX_op_chsf64: {
    long param1, param2;
    extern void op_chsf64();
extern char helper_get_opf64;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_chsf64+0), 35);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 13) = param1 - (long)(gen_code_ptr + 13) + -4;
    *(uint32_t *)(gen_code_ptr + 31) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 31) + -4;
    gen_code_ptr += 35;
}
break;

case INDEX_op_sqrtf64: {
    long param1, param2;
    extern void op_sqrtf64();
extern char helper_get_opf64;
extern char float64_sqrt;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_sqrtf64+0), 48);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 26) = (long)(&float64_sqrt) - (long)(gen_code_ptr + 26) + -4;
    *(uint32_t *)(gen_code_ptr + 32) = param1 - (long)(gen_code_ptr + 32) + -4;
    *(uint32_t *)(gen_code_ptr + 40) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 40) + -4;
    gen_code_ptr += 48;
}
break;

case INDEX_op_addf64: {
    long param1, param2, param3;
    extern void op_addf64();
extern char helper_get_opf64;
extern char helper_get_opf64;
extern char float64_add;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_addf64+0), 59);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param2 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param3 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 22) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 22) + -4;
    *(uint32_t *)(gen_code_ptr + 40) = (long)(&float64_add) - (long)(gen_code_ptr + 40) + -4;
    *(uint32_t *)(gen_code_ptr + 46) = param1 - (long)(gen_code_ptr + 46) + -4;
    *(uint32_t *)(gen_code_ptr + 54) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 54) + -4;
    gen_code_ptr += 59;
}
break;

case INDEX_op_subf64: {
    long param1, param2, param3;
    extern void op_subf64();
extern char helper_get_opf64;
extern char helper_get_opf64;
extern char float64_sub;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_subf64+0), 59);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param2 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param3 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 22) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 22) + -4;
    *(uint32_t *)(gen_code_ptr + 40) = (long)(&float64_sub) - (long)(gen_code_ptr + 40) + -4;
    *(uint32_t *)(gen_code_ptr + 46) = param1 - (long)(gen_code_ptr + 46) + -4;
    *(uint32_t *)(gen_code_ptr + 54) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 54) + -4;
    gen_code_ptr += 59;
}
break;

case INDEX_op_mulf64: {
    long param1, param2, param3;
    extern void op_mulf64();
extern char helper_get_opf64;
extern char helper_get_opf64;
extern char float64_mul;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_mulf64+0), 59);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param2 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param3 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 22) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 22) + -4;
    *(uint32_t *)(gen_code_ptr + 40) = (long)(&float64_mul) - (long)(gen_code_ptr + 40) + -4;
    *(uint32_t *)(gen_code_ptr + 46) = param1 - (long)(gen_code_ptr + 46) + -4;
    *(uint32_t *)(gen_code_ptr + 54) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 54) + -4;
    gen_code_ptr += 59;
}
break;

case INDEX_op_divf64: {
    long param1, param2, param3;
    extern void op_divf64();
extern char helper_get_opf64;
extern char helper_get_opf64;
extern char float64_div;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_divf64+0), 59);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param2 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param3 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 22) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 22) + -4;
    *(uint32_t *)(gen_code_ptr + 40) = (long)(&float64_div) - (long)(gen_code_ptr + 40) + -4;
    *(uint32_t *)(gen_code_ptr + 46) = param1 - (long)(gen_code_ptr + 46) + -4;
    *(uint32_t *)(gen_code_ptr + 54) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 54) + -4;
    gen_code_ptr += 59;
}
break;

case INDEX_op_iround_f64: {
    long param1, param2;
    extern void op_iround_f64();
extern char helper_get_opf64;
extern char float64_round_to_int;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_iround_f64+0), 48);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 26) = (long)(&float64_round_to_int) - (long)(gen_code_ptr + 26) + -4;
    *(uint32_t *)(gen_code_ptr + 32) = param1 - (long)(gen_code_ptr + 32) + -4;
    *(uint32_t *)(gen_code_ptr + 40) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 40) + -4;
    gen_code_ptr += 48;
}
break;

case INDEX_op_itrunc_f64: {
    long param1, param2;
    extern void op_itrunc_f64();
extern char helper_get_opf64;
extern char float64_trunc_to_int;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_itrunc_f64+0), 48);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 26) = (long)(&float64_trunc_to_int) - (long)(gen_code_ptr + 26) + -4;
    *(uint32_t *)(gen_code_ptr + 32) = param1 - (long)(gen_code_ptr + 32) + -4;
    *(uint32_t *)(gen_code_ptr + 40) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 40) + -4;
    gen_code_ptr += 48;
}
break;

case INDEX_op_compare_quietf64: {
    long param1, param2, param3;
    extern void op_compare_quietf64();
extern char helper_get_opf64;
extern char helper_get_opf64;
extern char float64_compare_quiet;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_compare_quietf64+0), 58);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    param3 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param2 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param3 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 22) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 22) + -4;
    *(uint32_t *)(gen_code_ptr + 40) = (long)(&float64_compare_quiet) - (long)(gen_code_ptr + 40) + -4;
    *(uint32_t *)(gen_code_ptr + 46) = param1 - (long)(gen_code_ptr + 46) + -4;
    *(uint32_t *)(gen_code_ptr + 53) = (long)(&helper_set_op) - (long)(gen_code_ptr + 53) + -4;
    gen_code_ptr += 58;
}
break;

case INDEX_op_movec: {
    long param1, param2;
    extern void op_movec();
extern char helper_get_op;
extern char helper_get_op;
extern char helper_movec;
    memcpy(gen_code_ptr, (void *)((char *)&op_movec+0), 38);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param1 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param2 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    *(uint32_t *)(gen_code_ptr + 33) = (long)(&helper_movec) - (long)(gen_code_ptr + 33) + -4;
    gen_code_ptr += 38;
}
break;

case INDEX_op_ld8u32_raw: {
    long param1, param2;
    extern void op_ld8u32_raw();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ld8u32_raw+0), 27);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param1 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_set_op) - (long)(gen_code_ptr + 23) + -4;
    gen_code_ptr += 27;
}
break;

case INDEX_op_ld8s32_raw: {
    long param1, param2;
    extern void op_ld8s32_raw();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ld8s32_raw+0), 27);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param1 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_set_op) - (long)(gen_code_ptr + 23) + -4;
    gen_code_ptr += 27;
}
break;

case INDEX_op_ld16u32_raw: {
    long param1, param2;
    extern void op_ld16u32_raw();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ld16u32_raw+0), 36);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param1 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 32) = (long)(&helper_set_op) - (long)(gen_code_ptr + 32) + -4;
    gen_code_ptr += 36;
}
break;

case INDEX_op_ld16s32_raw: {
    long param1, param2;
    extern void op_ld16s32_raw();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ld16s32_raw+0), 40);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 15) = param1 - (long)(gen_code_ptr + 15) + -4;
    *(uint32_t *)(gen_code_ptr + 36) = (long)(&helper_set_op) - (long)(gen_code_ptr + 36) + -4;
    gen_code_ptr += 40;
}
break;

case INDEX_op_ld32_raw: {
    long param1, param2;
    extern void op_ld32_raw();
extern char helper_get_op;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ld32_raw+0), 28);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 19) = param1 - (long)(gen_code_ptr + 19) + -4;
    *(uint32_t *)(gen_code_ptr + 24) = (long)(&helper_set_op) - (long)(gen_code_ptr + 24) + -4;
    gen_code_ptr += 28;
}
break;

case INDEX_op_st8_raw: {
    long param1, param2;
    extern void op_st8_raw();
extern char helper_get_op;
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_st8_raw+0), 28);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param1 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param2 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    gen_code_ptr += 28;
}
break;

case INDEX_op_st16_raw: {
    long param1, param2;
    extern void op_st16_raw();
extern char helper_get_op;
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_st16_raw+0), 36);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param1 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param2 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    gen_code_ptr += 36;
}
break;

case INDEX_op_st32_raw: {
    long param1, param2;
    extern void op_st32_raw();
extern char helper_get_op;
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_st32_raw+0), 30);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param1 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param2 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    gen_code_ptr += 30;
}
break;

case INDEX_op_ldf64_raw: {
    long param1, param2;
    extern void op_ldf64_raw();
extern char helper_get_op;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_ldf64_raw+0), 66);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param2 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 47) = param1 - (long)(gen_code_ptr + 47) + -4;
    *(uint32_t *)(gen_code_ptr + 61) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 61) + -4;
    gen_code_ptr += 66;
}
break;

case INDEX_op_stf64_raw: {
    long param1, param2;
    extern void op_stf64_raw();
extern char helper_get_op;
extern char helper_get_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_stf64_raw+0), 42);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param1 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param2 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 21) + -4;
    gen_code_ptr += 42;
}
break;

case INDEX_op_ld8u32_user: {
    long param1, param2;
    extern void op_ld8u32_user();
extern char helper_get_op;
extern char __ldb_mmu;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ld8u32_user+0), 97);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_op) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 60) = (long)(&__ldb_mmu) - (long)(gen_code_ptr + 60) + -4;
    *(uint32_t *)(gen_code_ptr + 84) = param1 - (long)(gen_code_ptr + 84) + -4;
    *(uint32_t *)(gen_code_ptr + 89) = (long)(&helper_set_op) - (long)(gen_code_ptr + 89) + -4;
    gen_code_ptr += 97;
}
break;

case INDEX_op_ld8s32_user: {
    long param1, param2;
    extern void op_ld8s32_user();
extern char helper_get_op;
extern char __ldb_mmu;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ld8s32_user+0), 97);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_op) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 60) = (long)(&__ldb_mmu) - (long)(gen_code_ptr + 60) + -4;
    *(uint32_t *)(gen_code_ptr + 84) = param1 - (long)(gen_code_ptr + 84) + -4;
    *(uint32_t *)(gen_code_ptr + 89) = (long)(&helper_set_op) - (long)(gen_code_ptr + 89) + -4;
    gen_code_ptr += 97;
}
break;

case INDEX_op_ld16u32_user: {
    long param1, param2;
    extern void op_ld16u32_user();
extern char helper_get_op;
extern char __ldw_mmu;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ld16u32_user+0), 106);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_op) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 60) = (long)(&__ldw_mmu) - (long)(gen_code_ptr + 60) + -4;
    *(uint32_t *)(gen_code_ptr + 93) = param1 - (long)(gen_code_ptr + 93) + -4;
    *(uint32_t *)(gen_code_ptr + 98) = (long)(&helper_set_op) - (long)(gen_code_ptr + 98) + -4;
    gen_code_ptr += 106;
}
break;

case INDEX_op_ld16s32_user: {
    long param1, param2;
    extern void op_ld16s32_user();
extern char helper_get_op;
extern char __ldw_mmu;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ld16s32_user+0), 110);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_op) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 60) = (long)(&__ldw_mmu) - (long)(gen_code_ptr + 60) + -4;
    *(uint32_t *)(gen_code_ptr + 97) = param1 - (long)(gen_code_ptr + 97) + -4;
    *(uint32_t *)(gen_code_ptr + 102) = (long)(&helper_set_op) - (long)(gen_code_ptr + 102) + -4;
    gen_code_ptr += 110;
}
break;

case INDEX_op_ld32_user: {
    long param1, param2;
    extern void op_ld32_user();
extern char helper_get_op;
extern char __ldl_mmu;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ld32_user+0), 97);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_op) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 60) = (long)(&__ldl_mmu) - (long)(gen_code_ptr + 60) + -4;
    *(uint32_t *)(gen_code_ptr + 84) = param1 - (long)(gen_code_ptr + 84) + -4;
    *(uint32_t *)(gen_code_ptr + 89) = (long)(&helper_set_op) - (long)(gen_code_ptr + 89) + -4;
    gen_code_ptr += 97;
}
break;

case INDEX_op_st8_user: {
    long param1, param2;
    extern void op_st8_user();
extern char helper_get_op;
extern char helper_get_op;
extern char __stb_mmu;
    memcpy(gen_code_ptr, (void *)((char *)&op_st8_user+0), 94);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param1 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param2 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    *(uint32_t *)(gen_code_ptr + 75) = (long)(&__stb_mmu) - (long)(gen_code_ptr + 75) + -4;
    gen_code_ptr += 94;
}
break;

case INDEX_op_st16_user: {
    long param1, param2;
    extern void op_st16_user();
extern char helper_get_op;
extern char helper_get_op;
extern char __stw_mmu;
    memcpy(gen_code_ptr, (void *)((char *)&op_st16_user+0), 102);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param1 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param2 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    *(uint32_t *)(gen_code_ptr + 75) = (long)(&__stw_mmu) - (long)(gen_code_ptr + 75) + -4;
    gen_code_ptr += 102;
}
break;

case INDEX_op_st32_user: {
    long param1, param2;
    extern void op_st32_user();
extern char helper_get_op;
extern char helper_get_op;
extern char __stl_mmu;
    memcpy(gen_code_ptr, (void *)((char *)&op_st32_user+0), 95);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param1 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param2 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    *(uint32_t *)(gen_code_ptr + 74) = (long)(&__stl_mmu) - (long)(gen_code_ptr + 74) + -4;
    gen_code_ptr += 95;
}
break;

case INDEX_op_ldf64_user: {
    long param1, param2;
    extern void op_ldf64_user();
extern char helper_get_op;
extern char __ldq_mmu;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_ldf64_user+0), 115);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_op) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 60) = (long)(&__ldq_mmu) - (long)(gen_code_ptr + 60) + -4;
    *(uint32_t *)(gen_code_ptr + 102) = param1 - (long)(gen_code_ptr + 102) + -4;
    *(uint32_t *)(gen_code_ptr + 107) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 107) + -4;
    gen_code_ptr += 115;
}
break;

case INDEX_op_stf64_user: {
    long param1, param2;
    extern void op_stf64_user();
extern char helper_get_op;
extern char helper_get_opf64;
extern char __stq_mmu;
    memcpy(gen_code_ptr, (void *)((char *)&op_stf64_user+0), 109);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param1 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param2 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 21) + -4;
    *(uint32_t *)(gen_code_ptr + 76) = (long)(&__stq_mmu) - (long)(gen_code_ptr + 76) + -4;
    gen_code_ptr += 109;
}
break;

case INDEX_op_ld8u32_kernel: {
    long param1, param2;
    extern void op_ld8u32_kernel();
extern char helper_get_op;
extern char __ldb_mmu;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ld8u32_kernel+0), 94);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_op) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 57) = (long)(&__ldb_mmu) - (long)(gen_code_ptr + 57) + -4;
    *(uint32_t *)(gen_code_ptr + 81) = param1 - (long)(gen_code_ptr + 81) + -4;
    *(uint32_t *)(gen_code_ptr + 86) = (long)(&helper_set_op) - (long)(gen_code_ptr + 86) + -4;
    gen_code_ptr += 94;
}
break;

case INDEX_op_ld8s32_kernel: {
    long param1, param2;
    extern void op_ld8s32_kernel();
extern char helper_get_op;
extern char __ldb_mmu;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ld8s32_kernel+0), 94);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_op) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 57) = (long)(&__ldb_mmu) - (long)(gen_code_ptr + 57) + -4;
    *(uint32_t *)(gen_code_ptr + 81) = param1 - (long)(gen_code_ptr + 81) + -4;
    *(uint32_t *)(gen_code_ptr + 86) = (long)(&helper_set_op) - (long)(gen_code_ptr + 86) + -4;
    gen_code_ptr += 94;
}
break;

case INDEX_op_ld16u32_kernel: {
    long param1, param2;
    extern void op_ld16u32_kernel();
extern char helper_get_op;
extern char __ldw_mmu;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ld16u32_kernel+0), 103);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_op) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 57) = (long)(&__ldw_mmu) - (long)(gen_code_ptr + 57) + -4;
    *(uint32_t *)(gen_code_ptr + 90) = param1 - (long)(gen_code_ptr + 90) + -4;
    *(uint32_t *)(gen_code_ptr + 95) = (long)(&helper_set_op) - (long)(gen_code_ptr + 95) + -4;
    gen_code_ptr += 103;
}
break;

case INDEX_op_ld16s32_kernel: {
    long param1, param2;
    extern void op_ld16s32_kernel();
extern char helper_get_op;
extern char __ldw_mmu;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ld16s32_kernel+0), 107);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_op) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 57) = (long)(&__ldw_mmu) - (long)(gen_code_ptr + 57) + -4;
    *(uint32_t *)(gen_code_ptr + 94) = param1 - (long)(gen_code_ptr + 94) + -4;
    *(uint32_t *)(gen_code_ptr + 99) = (long)(&helper_set_op) - (long)(gen_code_ptr + 99) + -4;
    gen_code_ptr += 107;
}
break;

case INDEX_op_ld32_kernel: {
    long param1, param2;
    extern void op_ld32_kernel();
extern char helper_get_op;
extern char __ldl_mmu;
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_ld32_kernel+0), 94);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_op) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 57) = (long)(&__ldl_mmu) - (long)(gen_code_ptr + 57) + -4;
    *(uint32_t *)(gen_code_ptr + 81) = param1 - (long)(gen_code_ptr + 81) + -4;
    *(uint32_t *)(gen_code_ptr + 86) = (long)(&helper_set_op) - (long)(gen_code_ptr + 86) + -4;
    gen_code_ptr += 94;
}
break;

case INDEX_op_st8_kernel: {
    long param1, param2;
    extern void op_st8_kernel();
extern char helper_get_op;
extern char helper_get_op;
extern char __stb_mmu;
    memcpy(gen_code_ptr, (void *)((char *)&op_st8_kernel+0), 91);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param1 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param2 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    *(uint32_t *)(gen_code_ptr + 72) = (long)(&__stb_mmu) - (long)(gen_code_ptr + 72) + -4;
    gen_code_ptr += 91;
}
break;

case INDEX_op_st16_kernel: {
    long param1, param2;
    extern void op_st16_kernel();
extern char helper_get_op;
extern char helper_get_op;
extern char __stw_mmu;
    memcpy(gen_code_ptr, (void *)((char *)&op_st16_kernel+0), 99);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param1 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param2 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    *(uint32_t *)(gen_code_ptr + 72) = (long)(&__stw_mmu) - (long)(gen_code_ptr + 72) + -4;
    gen_code_ptr += 99;
}
break;

case INDEX_op_st32_kernel: {
    long param1, param2;
    extern void op_st32_kernel();
extern char helper_get_op;
extern char helper_get_op;
extern char __stl_mmu;
    memcpy(gen_code_ptr, (void *)((char *)&op_st32_kernel+0), 92);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param1 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param2 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    *(uint32_t *)(gen_code_ptr + 71) = (long)(&__stl_mmu) - (long)(gen_code_ptr + 71) + -4;
    gen_code_ptr += 92;
}
break;

case INDEX_op_ldf64_kernel: {
    long param1, param2;
    extern void op_ldf64_kernel();
extern char helper_get_op;
extern char __ldq_mmu;
extern char helper_set_opf64;
    memcpy(gen_code_ptr, (void *)((char *)&op_ldf64_kernel+0), 112);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_op) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 57) = (long)(&__ldq_mmu) - (long)(gen_code_ptr + 57) + -4;
    *(uint32_t *)(gen_code_ptr + 99) = param1 - (long)(gen_code_ptr + 99) + -4;
    *(uint32_t *)(gen_code_ptr + 104) = (long)(&helper_set_opf64) - (long)(gen_code_ptr + 104) + -4;
    gen_code_ptr += 112;
}
break;

case INDEX_op_stf64_kernel: {
    long param1, param2;
    extern void op_stf64_kernel();
extern char helper_get_op;
extern char helper_get_opf64;
extern char __stq_mmu;
    memcpy(gen_code_ptr, (void *)((char *)&op_stf64_kernel+0), 106);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param1 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param2 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_opf64) - (long)(gen_code_ptr + 21) + -4;
    *(uint32_t *)(gen_code_ptr + 73) = (long)(&__stq_mmu) - (long)(gen_code_ptr + 73) + -4;
    gen_code_ptr += 106;
}
break;

case INDEX_op_macmuls: {
    long param1, param2;
    extern void op_macmuls();
extern char helper_get_op;
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_macmuls+0), 106);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param1 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param2 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    gen_code_ptr += 106;
}
break;

case INDEX_op_macmulu: {
    long param1, param2;
    extern void op_macmulu();
extern char helper_get_op;
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_macmulu+0), 101);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param1 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param2 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    gen_code_ptr += 101;
}
break;

case INDEX_op_macmulf: {
    long param1, param2;
    extern void op_macmulf();
extern char helper_get_op;
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_macmulf+0), 92);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param1 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = (long)(&helper_get_op) - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = param2 - (long)(gen_code_ptr + 14) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&helper_get_op) - (long)(gen_code_ptr + 21) + -4;
    gen_code_ptr += 92;
}
break;

case INDEX_op_macshl: {
    extern void op_macshl();
    memcpy(gen_code_ptr, (void *)((char *)&op_macshl+0), 7);
    gen_code_ptr += 7;
}
break;

case INDEX_op_macshr: {
    extern void op_macshr();
    memcpy(gen_code_ptr, (void *)((char *)&op_macshr+0), 7);
    gen_code_ptr += 7;
}
break;

case INDEX_op_macadd: {
    long param1;
    extern void op_macadd();
    memcpy(gen_code_ptr, (void *)((char *)&op_macadd+0), 23);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    gen_code_ptr += 23;
}
break;

case INDEX_op_macsub: {
    long param1;
    extern void op_macsub();
    memcpy(gen_code_ptr, (void *)((char *)&op_macsub+0), 32);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    gen_code_ptr += 32;
}
break;

case INDEX_op_macsats: {
    long param1;
    extern void op_macsats();
    memcpy(gen_code_ptr, (void *)((char *)&op_macsats+0), 108);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    gen_code_ptr += 108;
}
break;

case INDEX_op_macsatu: {
    long param1;
    extern void op_macsatu();
    memcpy(gen_code_ptr, (void *)((char *)&op_macsatu+0), 61);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    gen_code_ptr += 61;
}
break;

case INDEX_op_macsatf: {
    long param1;
    extern void op_macsatf();
    memcpy(gen_code_ptr, (void *)((char *)&op_macsatf+0), 113);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    gen_code_ptr += 113;
}
break;

case INDEX_op_mac_clear_flags: {
    extern void op_mac_clear_flags();
    memcpy(gen_code_ptr, (void *)((char *)&op_mac_clear_flags+0), 8);
    gen_code_ptr += 8;
}
break;

case INDEX_op_mac_set_flags: {
    long param1;
    extern void op_mac_set_flags();
    memcpy(gen_code_ptr, (void *)((char *)&op_mac_set_flags+0), 147);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    gen_code_ptr += 147;
}
break;

case INDEX_op_get_macf: {
    long param1, param2;
    extern void op_get_macf();
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_get_macf+0), 222);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 10) = param2 - (long)(gen_code_ptr + 10) + -4;
    *(uint32_t *)(gen_code_ptr + 213) = param1 - (long)(gen_code_ptr + 213) + -4;
    *(uint32_t *)(gen_code_ptr + 218) = (long)(&helper_set_op) - (long)(gen_code_ptr + 218) + -4;
    gen_code_ptr += 222;
}
break;

case INDEX_op_get_maci: {
    long param1, param2;
    extern void op_get_maci();
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_get_maci+0), 27);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = param1 - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 23) = (long)(&helper_set_op) - (long)(gen_code_ptr + 23) + -4;
    gen_code_ptr += 27;
}
break;

case INDEX_op_get_macs: {
    long param1, param2;
    extern void op_get_macs();
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_get_macs+0), 49);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 40) = param1 - (long)(gen_code_ptr + 40) + -4;
    *(uint32_t *)(gen_code_ptr + 45) = (long)(&helper_set_op) - (long)(gen_code_ptr + 45) + -4;
    gen_code_ptr += 49;
}
break;

case INDEX_op_get_macu: {
    long param1, param2;
    extern void op_get_macu();
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_get_macu+0), 43);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 13) = param1 - (long)(gen_code_ptr + 13) + -4;
    *(uint32_t *)(gen_code_ptr + 39) = (long)(&helper_set_op) - (long)(gen_code_ptr + 39) + -4;
    gen_code_ptr += 43;
}
break;

case INDEX_op_clear_mac: {
    long param1;
    extern void op_clear_mac();
    memcpy(gen_code_ptr, (void *)((char *)&op_clear_mac+0), 37);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    gen_code_ptr += 37;
}
break;

case INDEX_op_move_mac: {
    long param1, param2;
    extern void op_move_mac();
    memcpy(gen_code_ptr, (void *)((char *)&op_move_mac+0), 74);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = param1 - (long)(gen_code_ptr + 8) + -4;
    gen_code_ptr += 74;
}
break;

case INDEX_op_get_mac_extf: {
    long param1, param2;
    extern void op_get_mac_extf();
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_get_mac_extf+0), 71);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = param1 - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 67) = (long)(&helper_set_op) - (long)(gen_code_ptr + 67) + -4;
    gen_code_ptr += 71;
}
break;

case INDEX_op_get_mac_exti: {
    long param1, param2;
    extern void op_get_mac_exti();
extern char helper_set_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_get_mac_exti+0), 45);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param2 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 8) = param1 - (long)(gen_code_ptr + 8) + -4;
    *(uint32_t *)(gen_code_ptr + 41) = (long)(&helper_set_op) - (long)(gen_code_ptr + 41) + -4;
    gen_code_ptr += 45;
}
break;

case INDEX_op_set_macf: {
    long param1, param2;
    extern void op_set_macf();
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_set_macf+0), 54);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param1 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = param2 - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = (long)(&helper_get_op) - (long)(gen_code_ptr + 14) + -4;
    gen_code_ptr += 54;
}
break;

case INDEX_op_set_macs: {
    long param1, param2;
    extern void op_set_macs();
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_set_macs+0), 50);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param1 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = param2 - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = (long)(&helper_get_op) - (long)(gen_code_ptr + 14) + -4;
    gen_code_ptr += 50;
}
break;

case INDEX_op_set_macu: {
    long param1, param2;
    extern void op_set_macu();
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_set_macu+0), 50);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 3) = param1 - (long)(gen_code_ptr + 3) + -4;
    *(uint32_t *)(gen_code_ptr + 9) = param2 - (long)(gen_code_ptr + 9) + -4;
    *(uint32_t *)(gen_code_ptr + 14) = (long)(&helper_get_op) - (long)(gen_code_ptr + 14) + -4;
    gen_code_ptr += 50;
}
break;

case INDEX_op_set_mac_extf: {
    long param1, param2;
    extern void op_set_mac_extf();
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_set_mac_extf+0), 116);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 13) = param2 - (long)(gen_code_ptr + 13) + -4;
    gen_code_ptr += 116;
}
break;

case INDEX_op_set_mac_exts: {
    long param1, param2;
    extern void op_set_mac_exts();
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_set_mac_exts+0), 60);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 13) = param2 - (long)(gen_code_ptr + 13) + -4;
    gen_code_ptr += 60;
}
break;

case INDEX_op_set_mac_extu: {
    long param1, param2;
    extern void op_set_mac_extu();
extern char helper_get_op;
    memcpy(gen_code_ptr, (void *)((char *)&op_set_mac_extu+0), 48);
    param1 = *opparam_ptr++;
    param2 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 7) = (long)(&helper_get_op) - (long)(gen_code_ptr + 7) + -4;
    *(uint32_t *)(gen_code_ptr + 13) = param2 - (long)(gen_code_ptr + 13) + -4;
    gen_code_ptr += 48;
}
break;

case INDEX_op_set_macsr: {
    long param1;
    extern void op_set_macsr();
extern char helper_get_op;
extern char m68k_set_macsr;
    memcpy(gen_code_ptr, (void *)((char *)&op_set_macsr+0), 29);
    param1 = *opparam_ptr++;
    *(uint32_t *)(gen_code_ptr + 2) = param1 - (long)(gen_code_ptr + 2) + -4;
    *(uint32_t *)(gen_code_ptr + 11) = (long)(&helper_get_op) - (long)(gen_code_ptr + 11) + -4;
    *(uint32_t *)(gen_code_ptr + 21) = (long)(&m68k_set_macsr) - (long)(gen_code_ptr + 21) + -4;
    gen_code_ptr += 29;
}
break;

        case INDEX_op_nop:
            break;
        case INDEX_op_nop1:
            opparam_ptr++;
            break;
        case INDEX_op_nop2:
            opparam_ptr += 2;
            break;
        case INDEX_op_nop3:
            opparam_ptr += 3;
            break;
        default:
            goto the_end;
        }
    }
 the_end:
flush_icache_range((unsigned long)gen_code_buf, (unsigned long)gen_code_ptr);
return gen_code_ptr -  gen_code_buf;
}

